function ok = checkBt( bt )

% Angewandte Numerik 2, Wintersemester 2016/2017, 20.01.2017
% Uebungsblatt 10, Aufgabe 31: Weitere Einschrittverfahren
%
% checkBt ueberprueft das Butchertableau eines Runge-Kutta-Verfahrens
% Achtung: Es wird nicht ueberprueft,
% ob Butchertableau zu einem expliziten Runge-Kutta-Verfahren gehoert
%
% Parameter:
%   bt:     Butcher-Tableau als Struktur mit den Komponenten
%           - bt.m:     die Stufenzahl des Runge-Kutta-Verfahrens
%           - bt.alpha: der Spaltenvektor alpha des RK-Verfahrens
%           - bt.beta:  die Matrix beta des RK-Verfahrens
%           - bt.gamma: der Zeilenvektor beta des RK-Verfahrens
%
% Rueckgabewert:
%   ok:     Wahrheitswert: True, falls Ueberpruefung erfolgreich ist



[ma, na] = size(bt.alpha);
[mb, nb] = size(bt.beta);
[mg, ng] = size(bt.gamma);

if (ma ~= bt.m) || (na ~= 1)
    error('Dimension von alpha stimmt nicht');
end

if (mb ~= bt.m) || (nb ~= bt.m)
    error('Dimension von beta stimmt nicht');
end

if (mg ~= 1) || (ng ~= bt.m)
    error('Dimension von gamma stimmt nicht');
end

for i = 2:mb
    if (sum(bt.beta(i,1:i-1)) ~= bt.alpha(i))
        error('In Zeile %d von beta stimmt Zeilensumme nicht', i);
    end
end

ok = true;
    
end

