function yk = eulerExplizit(f, y0, tk)

% Angewandte Numerik 2, Wintersemester 2016/2017, 13.01.2017
% Uebungsblatt 09, Aufgabe 30: Vergleich verschiedener Einschrittverfahren
%
% eulerExplizit fuehrt das explizite Euler-Verfahren zur Loesung
%        	einer Anfangswertaufgabe y' = f(t,y), y(t0) = y0 durch
%
% Parameter:
%   f:      function handle der Funktion f(t,y)
%   y0:     Anfangswert der Anfangswertaufgabe
%   tk:     Gitter mit den diskreten Zeitpunkten, an denen eine
%           Naeherungsloesung der AWA berechnet werden soll
%
% Rueckgabewert:
%   yk:     Vektor der einzelnen Naeherungswerte an den Gitterpunkten



N  = length(tk);                    % Anzahl Auswertezeitpunkte im Gitter
yk = zeros(length(y0),N);
  
yk(:,1) = y0;                       % Anfangswert eintragen in Vektor

for k = 1:N-1                       % durchlaufe alle Gitterpunkte
    h         = tk(k+1)-tk(k);      % aktuelle Schrittweite
    yk(:,k+1) = yk(:,k) + h*f(tk(k),yk(:,k));   % explizites Eulerverfahren
end

end